///////////////////////////////////////////
// level.wdl
///////////////////////////////////////////
var video_mode = 7;
var video_depth = 32;
var video_screen = 2;
var AI;
var pl_startpos[3] = 0,255,-100;
var AI_startpos[3] = 0,-255,-100;
var pl_HP_bar;
var AI_HP_bar;
var difficulty = 0;
///////////////////////////////////////////
string fighter = "ball.mdl";
string rocket = "rocket.mdl";
///////////////////////////////////////////
function _player();
function _AI();
function fire_rocket(_handle);
function player_rocket();
function AI_rocket();
function handle_menu();
function show_menu();
function toggle_menu();
///////////////////////////////////////////
function particle_a_default();
function particle_a_red();
function particle_a_green();
function particle_a_green_blur();
function particle_b_default();
function particle_b_red();
function particle_b_green();
///////////////////////////////////////////
bmap part_a_default = "flare_a_default.tga";
bmap part_a_red = "flare_a_red.tga";
bmap part_a_green = "flare_a_green.tga";
bmap part_a_green_blur = "flare_a_green2.tga";
bmap part_b_default = "flaresoft_sky.tga";
bmap part_b_red = "flaresoft_warm.tga";
bmap part_b_green = "flaresoft_comet.tga";
///////////////////////////////////////////
bmap HP_bar_pl = "HP_bar_left.tga";
bmap HP_bar_AI = "HP_bar_right.tga";
bmap HP_bg = "HP_bg.tga";
bmap menu_back = "menu_a.tga";
bmap cursor_map = "cursor.tga";
///////////////////////////////////////////
bind <flare_a_default.tga>;
bind <flare_a_red.tga>;
bind <flare_a_green.tga>;
bind <flare_a_green2.tga>;
bind <flaresoft_sky.tga>;
bind <flaresoft_warm.tga>;
bind <flaresoft_comet.tga>;
bind <HP_bar_left.tga>;
bind <HP_bar_right.tga>;
bind <HP_bg.tga>;
bind <menu_a.tga>;
bind <cursor.tga>;
bind <ball.mdl>;
bind <rocket.mdl>;
bind <sky.mdl>;
bind <readme.txt>;
///////////////////////////////////////////
define speed_x,skill1;
define speed_y,skill2;
define health,skill3;
define fire_time,skill4;
define owner,skill5;
define explode,skill6;
define scan_mode,skill7;
define _alpha,skill1;
define _rotate_pan,skill2;
define _rotate_tilt,skill3;
define _rotate_roll,skill4;
///////////////////////////////////////////
material mat_rocket
{
	emissive_red = 20;
	emissive_green = 200;
	emissive_blue = 255;
	ambient_red = 20;
	ambient_green = 200;
	ambient_blue = 255;
	specular_red = 20;
	specular_green = 200;
	specular_blue = 255;
	diffuse_red = 20;
	diffuse_green = 200;
	diffuse_blue = 255;
	power = 3;
}
///////////////////////////////////////////
panel pl_hpbar()
{
	bmap = HP_bg;
	pos_x = 5;
	pos_y = 5;
	layer = 10;
	window = 1,1,200,18,HP_bar_pl,pl_HP_bar,0;
	flags = refresh;
}
///////////////////////////////////////////
panel AI_hpbar()
{
	bmap = HP_bg;
	pos_x = 210;
	pos_y = 5;
	layer = 10;
	window = 1,1,200,18,HP_bar_AI,AI_HP_bar,0;
	flags = refresh;
}
///////////////////////////////////////////
panel menu()
{
	bmap = menu_back;
	layer = 15;
	flags = visible,refresh;
	on_click = handle_menu;
}
///////////////////////////////////////////
function handle_menu()
{
	var mouse_x;
	mouse_x = mouse_pos.x - ((screen_size.x - bmap_width(menu_back)) / 2);
	var mouse_y;
	mouse_y = mouse_pos.y - ((screen_size.y - bmap_height(menu_back)) / 2);
	if(mouse_x > 53 && mouse_x < 143)
	{
		if(mouse_y > 53 && mouse_y < 80)
		{
			difficulty = 1;
			wait(3);
			main();
			menu.visible = off;
			mouse_mode = 0;
		}
		if(mouse_y > 89 && mouse_y < 112)
		{
			difficulty = 2;
			wait(3);
			main();
			menu.visible = off;
			mouse_mode = 0;
		}
		if(mouse_y > 125 && mouse_y < 146)
		{
			difficulty = 3;
			wait(3);
			main();
			menu.visible = off;
			mouse_mode = 0;
		}
		if(mouse_y > 161 && mouse_y < 182)
		{
			difficulty = -1;
			wait(3);
			main();
			menu.visible = off;
			mouse_mode = 0;
		}
	}
}
///////////////////////////////////////////
function main()
{
	on_esc = null;
	proc_kill(4);
	freeze_mode = 0;
	level_load("level.wmb");
	wait(3);
	camera.z = 900;
	camera.tilt = -90;
	mouse_map = cursor_map;
	mouse_mode = 2;
	menu.visible = on;
	menu.pos_x = (screen_size.x - bmap_width(menu_back)) / 2;
	menu.pos_y = (screen_size.y - bmap_height(menu_back)) / 2;
	while(difficulty == 0) {wait(1);mouse_pos.x = pointer.x;mouse_pos.y = pointer.y;}
	if(difficulty == -1) {exit;}
	menu.visible = off;
	mouse_mode = 0;
	ent_create(fighter,pl_startpos,_player);
	ent_create(fighter,AI_startpos,_AI);
	
	on_esc = toggle_menu;
}
///////////////////////////////////////////
function show_menu()
{
	freeze_mode = 1;
	menu.visible = on;
	menu.pos_x = (screen_size.x - bmap_width(menu_back)) / 2;
	menu.pos_y = (screen_size.y - bmap_height(menu_back)) / 2;
	mouse_mode = 2;
	while(mouse_mode == 2)
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		wait(1);
	}
}
///////////////////////////////////////////
function toggle_menu()
{
	if(menu.visible == on)
	{
		mouse_mode = 0;
		freeze_mode = 0;
		menu.visible = off;
	}
	else
	{
		show_menu();
	}
}
///////////////////////////////////////////
function _player()
{
	pl_hpbar.visible = on;
	player = me;
	my.skin = 1;
	my.health = 100;
	my.fire_time = 10;
	while(my.health > 0)
	{
		pl_HP_bar = 200 - my.health * 2;
		if(my.fire_time < 1)
		{
			if(key_space)
			{
				fire_rocket(handle(my));
				my.fire_time = 30;
			}
		}
		
		my.fire_time = max(my.fire_time - (1*time),0);
		
		my.speed_x = (key_cuu - key_cud) * 25 * time;
		my.speed_y = (key_cul - key_cur) * 25 * time;
		
		my.x = clamp(my.x + my.speed_x,-365,365);
		my.y = clamp(my.y + my.speed_y,-365,365);
		
		wait(1);
	}
	pl_HP_bar = 200 - my.health * 2;
	effect(particle_b_default,2500,my.x,nullvector);
	remove me;
	sleep(2.5);
	difficulty = 0;
	main();
}
///////////////////////////////////////////
function _AI()
{
	AI_hpbar.visible = on;
	AI = handle(me);
	my.skin = 2;
	my.health = 100;
	my.fire_time = 40;
	while(my.health > 0)
	{
		AI_hpbar.pos_x = screen_size.x - bmap_width(HP_bg) - 5;
		AI_HP_bar = my.health * 2;
		if(random(1) < 0.05)
		{
			if(random(1) > 0.499)
			{
				my.speed_x = 10 * difficulty * time;
			}
			else
			{
				my.speed_x = -10 * difficulty * time;
			}
		}
		
		if(random(1) > 0.95)
		{
			if(random(1) > 0.499)
			{
				my.speed_y = 10 * difficulty * time;
			}
			else
			{
				my.speed_y = -10 * difficulty * time;
			}
		}
		
		if(my.fire_time < 1 && player)
		{
			fire_rocket(handle(my));
			my.fire_time = 80 / difficulty;
		}
		
		my.x = clamp(my.x + my.speed_x,-365,365);
		my.y = clamp(my.y + my.speed_y,-365,365);
		
		my.fire_time = max(my.fire_time - (1*time),0);
		
		wait(1);
	}
	AI_hpbar.pos_x = screen_size.x - bmap_width(HP_bg) - 5;
	AI_HP_bar = my.health * 2;
	effect(particle_b_red,2500,my.x,nullvector);
	remove me;
	sleep(2.5);
	difficulty = 0;
	main();
}
///////////////////////////////////////////
function fire_rocket(_handle)
{
	if(_handle == 0) {return;}
	you = ptr_for_handle(_handle);
	if(_handle == AI)
	{
		ent_create(rocket,you.x,AI_rocket);
	}
	else
	{
		ent_create(rocket,you.x,player_rocket);
	}
}
///////////////////////////////////////////
function AI_rocket()
{
	my.material = mat_rocket;
	vec_scale(my.scale_x,0.5);
	my.explode = 0;
	if(player)
	{
		vec_set(temp,player.x);
		vec_sub(temp,my.x);
		vec_to_angle(my.pan,temp);
		my.tilt = 0;
		my.roll = 0;
	}
	while(my.explode < 1)
	{
		if(my.x > 365 || my.x < -365 || my.y > 365 || my.y < -365)
		{
			my.explode = 1;
		}
		
		if(player && difficulty == 3 && random(1) > 0.99)
		{
			vec_set(temp,player.x);
			vec_sub(temp,my.x);
			vec_to_angle(my.pan,temp);
			my.tilt = 0;
			my.roll = 0;
		}
		
		if(player)
		{
			if(vec_dist(my.x,player.x) < 45)
			{
				player.health -= 15;
				my.explode = 1;
			}
		}
		
		vec_for_vertex(target,my,49);
		temp.x = fcos(my.pan,-5);
		temp.y = fsin(my.pan,-5);
		effect(particle_a_green_blur,3,target,temp);
		
		my.x += fcos(my.pan,30*time);
		my.y += fsin(my.pan,30*time);
		
		wait(1);
	}
	vec_set(target,my.x);
	target.x += (random(2) - random(2)) + (random(2) - random(2));
	target.y += (random(2) - random(2)) + (random(2) - random(2));
	target.z = my.z;
	effect(particle_b_default,60,target,nullvector);
	effect(particle_b_red,50,target,nullvector);
	effect(particle_b_green,50,target,nullvector);
	remove me;
}
///////////////////////////////////////////
function player_rocket()
{
	my.material = mat_rocket;
	my.explode = 0;
	//my.scan_mode = scan_rocket;
	vec_scale(my.scale_x,0.5);
	you = ptr_for_handle(AI);
	if(you)
	{
		vec_set(temp,you.x);
		vec_sub(temp,my.x);
		vec_to_angle(my.pan,temp);
		my.tilt = 0;
		my.roll = 0;
	}
	while(my.explode < 1)
	{
		if(my.x > 365 || my.x < -365 || my.y > 365 || my.y < -365)
		{
			my.explode = 1;
		}
		
		you = ptr_for_handle(AI);
		if(you)
		{
			if(vec_dist(my.x,you.x) < 45)
			{
				you.health -= 15;
				my.explode = 1;
			}
		}
		
		vec_for_vertex(target,my,49);
		temp.x = fcos(my.pan,-5);
		temp.y = fsin(my.pan,-5);
		effect(particle_a_green_blur,3,target,temp);
		
		my.x += fcos(my.pan,30*time);
		my.y += fsin(my.pan,30*time);
		
		if(key_w)
		{
			my.pan = 0;
		}
		if(key_s)
		{
			my.pan = 180;
		}
		if(key_d)
		{
			my.pan = 270;
		}
		if(key_a)
		{
			my.pan = 90;
		}
		
		wait(1);
	}
	vec_set(target,my.x);
	target.x += (random(2) - random(2)) + (random(2) - random(2));
	target.y += (random(2) - random(2)) + (random(2) - random(2));
	target.z = my.z;
	effect(particle_b_default,60,target,nullvector);
	effect(particle_b_red,50,target,nullvector);
	effect(particle_b_green,50,target,nullvector);
	
	remove me;
}
///////////////////////////////////////////
function particle_alpha_fade()
{
	my.alpha -= 5 * time;
	if(my.alpha < 0) {my.lifespan = 0;}
}
///////////////////////////////////////////
function particle_a_default()
{
	my.bmap = part_a_default;
	my.move = on;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 20 + random(10);
	my.size = 8;
	my.function = particle_alpha_fade;
}
///////////////////////////////////////////
function particle_a_red()
{
	my.bmap = part_a_red;
	my.move = on;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 20 + random(10);
	my.size = 8;
	my.function = particle_alpha_fade;
}
///////////////////////////////////////////
function particle_a_green()
{
	my.bmap = part_a_green;
	my.move = on;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 20 + random(10);
	my.size = 8;
	my.function = particle_alpha_fade;
}
///////////////////////////////////////////
function particle_a_green_blur()
{
	my.bmap = part_a_green_blur;
	my.move = on;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 20 + random(10);
	my.size = 8;
	my.function = particle_alpha_fade;
}
///////////////////////////////////////////
function particle_b_default()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 45;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = part_b_default;
	my.function = particle_alpha_fade;
}
///////////////////////////////////////////
function particle_b_red()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 45;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = part_b_red;
	my.function = particle_alpha_fade;
}
///////////////////////////////////////////
function particle_b_green()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 45;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = part_b_green;
	my.function = particle_alpha_fade;
}
///////////////////////////////////////////
// use: _alpha, _rotate_pan, _rotate_tilt, _rotate_roll
action sky
{
	my.alpha = my.skill1;
	while(1)
	{
		my.pan += my.skill2 * time;
		my.tilt += my.skill3 * time;
		my.roll += my.skill4 * time;
		wait(1);
	}
}
///////////////////////////////////////////